/***************************************************************
 * Name:      L4DDSSMain.h
 * Purpose:   Defines Application Frame
 * Author:    Hermann Hhne (hoehermann@gmx.de)
 * Created:   2009-01-29
 * Copyright: Hermann Hhne (www.hehoe.de)
 * License:
 **************************************************************/

#ifndef L4DDSSMAIN_H
#define L4DDSSMAIN_H

#include "RCon.h"
#include <wx/filefn.h>
#include <wx/stdpaths.h>
#include <wx/textdlg.h>
#include <wx/numdlg.h>
#include <wx/textfile.h>
#include <wx/msgdlg.h>
#include <wx/socket.h>
#include "L4DDSSApp.h"
#include "GUIFrame.h"

class L4DDSSFrame: public GUIFrame
{
    public:
        L4DDSSFrame(wxFrame *frame);
        ~L4DDSSFrame();
    private:
        virtual void OnClose(wxCloseEvent& event);
        virtual void OnQuit(wxCommandEvent& event);
        virtual void OnAbout(wxCommandEvent& event);
        virtual void OnConnect(wxCommandEvent& event);
        virtual void OnDisconnect(wxCommandEvent& event);
		virtual void OnButtonKickClick( wxCommandEvent& event );
		virtual void OnButtonBanClick( wxCommandEvent& event );
		virtual void OnButtonSendClick( wxCommandEvent& event );
		virtual void OnServerCommandArgumentKeyUp(wxKeyEvent &event);
        virtual void OnGetStatus(wxCommandEvent& event);
        virtual void OnSocketInput(wxSocketEvent& event);
		virtual void OnServerAnswersKillFocus( wxFocusEvent& event );
		virtual void OnServerAnswersSetFocus( wxFocusEvent& event );
		virtual void OnServerCommandSelectCombobox( wxCommandEvent& event );
		virtual void OnPlayerlistChoice( wxCommandEvent& event );
        void EnableControls(boolean b);
        wxSocketClient *m_sock;
        wxString statusinfo;
        bool gettingstatus, usercon, configfile, answershavefocus;
        void parseStatusInfo(wxString statusinfo);
        wxRConSocketClient *rcon;
        wxIPV4address addr;
        wxTextFile *textfile;
};

enum
{
  CLIENT_ID = 2000
};

const unsigned int BUFSIZE = 1024;
#endif // L4DDSSMAIN_H
