//
// Source RCon class by Shannon "Freman" Wynter
// --> http://fremnet.net/article/199/source-rcon-class
// poorly ported to wxWidgets by Hermann "Mc$core" Hhne
// --> http://hehoe.de/mcs
//
// THIS CLASS IS ALPHA!
// UNICODE NOT TESTED!
// COMMUNICATION WILL FAIL ON NON x86-PROCESSORS!
//

#include "RCon.h"

#include <wx/arrimpl.cpp>
WX_DEFINE_OBJARRAY(ArrayOfRConPackets);

wxRConSocketClient::wxRConSocketClient(wxSocketFlags flags) {
    Id = 0;
    this->wxRConSocketClient::SetFlags(flags); // prevent split packages
    this->wxSocketClient::SetTimeout(GENERALTIMEOUT); // dont wait too long
    }

// connect to the server
// should return bool and supply error via LastError()
int wxRConSocketClient::Connect(wxSockAddress& address, wxString password) {
    if (!this->wxSocketClient::Connect(address)) return this->wxSocketBase::LastError();
    int auth = this->Auth(password);
    if (auth != wxRCONSOCKET_OK) this->wxSocketBase::Close();
    return auth;
	}

// authenticate with the server
int wxRConSocketClient::Auth (wxString password) {
    Write(SERVERDATA_AUTH,password,wxT(""));
    ArrayOfRConPackets packets = PacketRead();
    if (packets.Count() < 1) {
        this->Close();
        return wxRCONSOCKET_NONRCON;
        }
    if (packets.Last().id == -1) {
        this->Close();
        if (packets.Item(0).string1.Find(wxT("ban")) == wxNOT_FOUND) return wxRCONSOCKET_AUTHFAIL;
        else return wxRCONSOCKET_BANNED;
        }
    return wxRCONSOCKET_OK;
	}

// read complete rcon packets from socket
ArrayOfRConPackets wxRConSocketClient::PacketRead () {
    int32_t size = 0;
    ArrayOfRConPackets packets;
    RConPacket packet;
    char *buffer, *nullstr;
    nullstr = new char[1];
    do {
        this->Read(&size,4);
        if ((size < 10)||(size > 4106)) {
            this->Close();
            packet.string1 = wxT("Recieved invalid packet size ");
            packet.string1 << size << wxT(".\n");
            packets.Clear();
            packets.Add(packet);
            return packets;
            }
        packet.length = size;
        this->Read(&packet.id,4);
        this->Read(&packet.cmd,4);
        buffer = new char[packet.length-9];
        this->Read(buffer,packet.length-9);
        packet.string1 = wxString(buffer,wxConvUTF8);
        delete[] buffer;
        this->Read(nullstr,1);
        packets.Add(packet);
        } while (this->WaitForRead(PACKETREADTIMEOUT));
    return packets;
    }

// send a rcon packet to the server
int32_t wxRConSocketClient::Write(const int32_t cmd , wxString s1 = wxT(""), wxString s2 = wxT("")) {
    RConPacket packet; // we don't really need a packet here...
    packet.id = ++Id;
    packet.cmd = cmd;
    packet.string1 = s1;
    //packet.string2 = s2; // s2 is always empty
    packet.length = 10+packet.string1.Length()+packet.string2.Length();
    this->wxSocketBase::Write(&packet.length,4);
    this->wxSocketBase::Write(&packet.id,4);
    this->wxSocketBase::Write(&packet.cmd,4);
    this->wxSocketBase::Write(packet.string1.mb_str(),packet.string1.Length()+1);
    this->wxSocketBase::Write(packet.string2.mb_str(),packet.string2.Length()+1);
    return packet.id;
}

// send a command to the server
void wxRConSocketClient::SendCommand(wxString command) {
    // TODO: check string for server confusing "s
    Write(SERVERDATA_EXECCOMMAND,command,wxT(""));
    }

// send a command and return the answer as a string
wxString wxRConSocketClient::RConCommand(wxString command) {
    SendCommand(command); // send command
    ArrayOfRConPackets packets = PacketRead(); // read answer as array of packets
    wxString answer = wxT("");
    // combine the rcon packets into one string:
    for (unsigned int i = 0; i < packets.GetCount(); i++) {
        answer += packets.Item(i).string1;
        if (packets.Item(i).id == -1) {
            this->Close();
            return wxT("ERROR: No authentication.");
            }
        }
    //Id = packets.Last().id; // from the protocol docs. potentially dangerous
    return answer;
}

// make sure that wxSOCKET_WAITALL is always set
void wxRConSocketClient::SetFlags(wxSocketFlags flags) {
    this->wxSocketClient::SetFlags(flags);
    this->wxSocketClient::SetFlags(wxSOCKET_WAITALL);
    };

wxRConSocketClient::~wxRConSocketClient() {

}
